/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.39 from the
 * contents of Radix.xs. Do not edit this file, edit Radix.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Radix.xs"
/* -*- Mode: C -*- */

#define PERL_NO_GET_CONTEXT 1

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "ppport.h"

#define BE4 1
#define LE4 2
#define BE8 3
#define LE8 4
#define LE12 5
#define BE12 6
#define LE12_x86 7
#define BE16 9
#define LE16 10
#define LE16_x86 11

#include "rconfig.h"

#define CUTOFF 16

#ifdef inline
#undef inline
#endif

#if defined(__GNU__)
#define inline __inline__
#else
#define inline
#endif


static void
print_keys(pTHX_ char *name, unsigned char **keys, int n, int byte) {
    int i;
    printf("%s[%d] %p:", name, byte, keys);
    for (i = 0; i < n; i++) {
        int j;
        UV acu = 0;
        printf(" ");
        for (j = byte; j >= 0; j--)
            printf("%02x", keys[i][j]);
        printf("(");
        for (j = byte; j >= 0; j--)
            printf("%c", (isalnum(keys[i][j]) ? keys[i][j] : '.'));
        printf(")");
    }
    printf("\n\n");
    fflush(stdout);
}

static void
print_blens(pTHX_ int *blens) {
    int i;
    printf("blens:");
    for (i = 0; i < 256; i++)
        printf(" %d", blens[i]);
    printf("\n\n");
    fflush(stdout);
}

static void
radix_sort_1(unsigned char **keys, unsigned char **temps, int n, int byte) {
    
    /* byte must be equal or greater than 0! */
    /* assert (byte >= 0); */

    if (n > CUTOFF) {
        unsigned char **bucket[256];
        int blen[256];
        int i;

        Zero(blen, 256, int);
        
        for (i = 0; i < n; i++)
            blen[keys[i][byte]]++;

        /* print_blens(blen); */
            
        bucket[0] = temps;
        for (i = 0; i < 255; i++)
            bucket[i + 1] = bucket[i] + blen[i];
    
        for (i = 0; i < n; i++)
            *(bucket[keys[i][byte]]++) = keys[i];

        if (byte > 0) {
            byte--;
            for (i = 0; i < 256; i++) {
                int bli = blen[i];
                if (bli) {
                    radix_sort_1(temps, keys, bli, byte);
                    keys += bli;
                    temps += bli;
                }
            }
        }
    }
    else {
        /* insertion sort */
            
        unsigned char **dest = (byte & 1) ? keys : temps;
        int i;

        for (i = 0; i < n; i++) {
            unsigned char *pivot = keys[i];
            int j = i;
            while (j) {
                int k;
                for (k = byte; k >= 0; k--) {
                    unsigned char db =  dest[j - 1][k];
                    
                    if (pivot[k] > db)
                        goto insert_now;

                    if (pivot[k] < db) {
                        /* printf("pivot is <\n"); */
                        dest[j] = dest[j - 1];
                        goto continue_loop_j;
                    }
                }
                break;
            continue_loop_j:
                --j;
            }
        insert_now:
            dest[j] = pivot;
        }
    }
}

static unsigned char *
init_keys(pTHX_
          SV **data, I32 offset, I32 ax, int n,
          SV *keygen,
          void (*sv_to_key)(pTHX_ SV *, unsigned char *, int, int *),
          unsigned char ***keys, unsigned char ***temps, int klen, int *byte) {
    unsigned char *start, *key;
    int i;
    SV **svkeys;

    Newx(*keys, n * 2, unsigned char *);
    SAVEFREEPV(*keys);
    *temps = *keys + n;
    
    Newx(start, n * klen, unsigned char);
    SAVEFREEPV(start);
    
    *byte = 0;
    key = start;

    for (i = 0; i < n; i++, key += klen) {
        SV *current = data ? data[i] : ST(i + offset);
        (*keys)[i] = key;
        if (keygen) {
            dSP;
            IV count;
            SV *result;
            /* printf ("calc key\n"); fflush(stdout); */
            ENTER;
            SAVETMPS;
            SAVE_DEFSV;
            DEFSV = sv_2mortal(current ? SvREFCNT_inc(current) : newSV(0));
            PUSHMARK(SP);
            PUTBACK;
            count = call_sv(keygen, G_SCALAR);
            SPAGAIN;
            if (count != 1)
                Perl_croak(aTHX_ "wrong number of results returned from key generation sub");
            result = POPs;
            (*sv_to_key)(aTHX_ result, key, klen, byte);
            FREETMPS;
            LEAVE;
        }
        else {
            (*sv_to_key)(aTHX_ current, key, klen, byte);
        }
        
    }
    return start;
}

static int
calc_klen_pv(pTHX_ SV **keys, I32 offset, I32 ax, int n) {
    int klen = 0;
    int i;

    for (i = 0; i < n; i++) {
        SV *current = keys ? keys[i] : ST(offset + i);
        if (current) {
            STRLEN cur = SvCUR(current);
            if (cur > klen)
                klen = cur;
        }
    }
    return klen;
}

static SV **
calc_svkeys(pTHX_ SV *keygen, SV **data, I32 offset, I32 ax, int n) {
    int i;
    SV **keys = 0;
    AV *av;

    av = newAV();
    sv_2mortal((SV*)av);
    av_extend(av, n);
    keys = AvARRAY(av);
        
    for (i = 0; i < n; i++) {
        dSP;
        IV count;
        SV *result;
        SV *current = data ? data[i] : ST(offset + i);
        ENTER;
        SAVETMPS;
        SAVE_DEFSV;
        DEFSV = sv_2mortal(current ? SvREFCNT_inc(current) : newSV(0));
        PUSHMARK(SP);
        PUTBACK;
        count = call_sv(keygen, G_SCALAR);
        SPAGAIN;
        if (count != 1)
            Perl_croak(aTHX_ "wrong number of results returned from key generation sub");
        keys[i] = result = POPs;
        if (result)
            SvREFCNT_inc(result);
        FREETMPS;
        LEAVE;
    }
    return keys;
}

static void
resort_as_keys(pTHX_ SV **data, SV **dest, unsigned char *start, unsigned char **keys, int n, int klen) {
    SV **sorted = (SV**)keys;
    int i;
    for (i = 0; i < n; i++) {
        int ix = (keys[i] - start) / klen;
        sorted[i] = data[ix];
    }
    Move(sorted, dest, n, SV *);
}

inline static void
uv_to_key(pTHX_ UV uv, unsigned char *key, int *byte) {
#if UV_FORMAT == LE4 || UV_FORMAT == LE8
    *((UV*)key) = uv;
    while (uv_byte_mask[*byte] & uv)
        (*byte)++;
#else
    int i;
    for (i = sizeof(UV) - 1; i >= 0; i--) {
        unsigned char uc = (uv >> (8 * i));
        key[i] = uc;
        if (uc && i > *byte)
            *byte = i;
    }
#endif
}

static void
sv_uv_to_key(pTHX_ SV *sv, unsigned char *key, int klen, int *byte) {
#if UV_FORMAT == LE4 || UV_FORMAT == LE8
    UV uv = SvUV(sv);
    *((UV*)key) = uv;
    while (uv_byte_mask[*byte] & uv)
        (*byte)++;
#else
    uv_to_key(aTHX_ SvUV(sv), key, byte);
#endif
}

static void
sv_ruv_to_key(pTHX_ SV *sv, unsigned char *key, int klen, int *byte) {
#if UV_FORMAT == LE4 || UV_FORMAT == LE8
    UV uv = ~SvUV(sv);
    *((UV*)key) = uv;
    while (uv_byte_mask[*byte] & uv)
        (*byte)++;
#else
    uv_to_key(aTHX_ ~SvUV(sv), key, byte);
#endif
}

static void
sv_iv_to_key(pTHX_ SV *iv, unsigned char *key, int klen, int *byte) {
#if UV_FORMAT == LE4 || UV_FORMAT == LE8
    UV uv = SvIV(iv) + (((UV)1) << (8 * sizeof(IV) - 1));
    *((UV*)key) = uv;
    while (uv_byte_mask[*byte] & uv)
        (*byte)++;
#else
    uv_to_key(aTHX_ SvIV(iv) + (((UV)1) << (8 * sizeof(IV) - 1)), key, byte);
#endif
}

static void
sv_riv_to_key(pTHX_ SV *iv, unsigned char *key, int klen, int *byte) {
#if UV_FORMAT == LE4 || UV_FORMAT == LE8
    UV uv = ~(UV)(SvIV(iv) + (((UV)1) << (8 * sizeof(IV) - 1)));
    *((UV*)key) = uv;
    while (uv_byte_mask[*byte] & uv)
        (*byte)++;
#else
    uv_to_key(aTHX_ ~(UV)(SvIV(iv) + (((UV)1) << (8 * sizeof(IV) - 1))), key, byte);
#endif
}

#if NV_FORMAT == LE12_x86 || NV_FORMAT == LE16_x86
#define NVBYTE1 10
#else
#define NVBYTE1 (sizeof(NV))
#endif

static void
nv_to_key(pTHX_ NV nv, unsigned char *key, int klen, int *byte) {
#if defined(NV_FORMAT)
    int i;
    *((NV *)key) = nv;
#if NV_FORMAT == BE8 || NV_FORMAT == BE12 || NV_FORMAT == BE16
    for (i = 0; i < (NVBYTE1 / 2); i++) {
        unsigned char tmp;
        tmp = key[i];
        key[i] = key[(NVBYTE1 - 1) - i];
        key[(NVBYTE1 - 1) - i] = tmp;
    }
#endif
    if (nv >= 0.0)
        key[NVBYTE1 - 1] |= 0x80;
    else
        for (i = 0; i < NVBYTE1; i++)
            key[i] = ~key[i];
    *byte = NVBYTE1 - 1;
#else
    Perl_croak(aTHX_ "Sorting of floating point keys is not supported on this computer. Please, send a bug report to Sort::Key::Radix author (0.124 => " NV_0124 ")");
#endif
}

static void
sv_nv_to_key(pTHX_ SV *sv, unsigned char *key, int klen, int *byte) {
    nv_to_key(aTHX_ SvNV(sv), key, klen, byte);
}

static void
sv_rnv_to_key(pTHX_ SV *sv, unsigned char *key, int klen, int *byte) {
    nv_to_key(aTHX_ -SvNV(sv), key, klen, byte);
}

static void
sf_to_key(pTHX_ float sf, unsigned char *key, int klen, int *byte) {
#if defined(SF_FORMAT)
    int i;
    *((float *)key) = sf;
#if SF_FORMAT == BE8 || SF_FORMAT == BE4 || SF_FORMAT == BE12 || SF_FORMAT == BE16
    for (i = 0; i < (sizeof(float) >> 1); i++) {
        unsigned char tmp;
        tmp = key[i];
        key[i] = key[(sizeof(float) - 1) - i];
        key[(sizeof(float) - 1) - i] = tmp;
    }
#endif
    if (sf >= 0.0)
        key[sizeof(float) - 1] |= 0x80;
    else
        for (i = 0; i < sizeof(float); i++)
            key[i] = ~key[i];
            *byte = sizeof(float) - 1;
#else
            Perl_croak(aTHX_ "Sorting of single floating point keys is not supported on this computer. Please, send a bug report to Sort::Key::Radix author  (0.124 => " SF_0124 ")");
#endif
}

static void
sv_sf_to_key(pTHX_ SV *sv, unsigned char *key, int klen, int *byte) {
    sf_to_key(aTHX_ SvNV(sv), key, klen, byte);
}

static void
sv_rsf_to_key(pTHX_ SV *sv, unsigned char *key, int klen, int *byte) {
    sf_to_key(aTHX_ -SvNV(sv), key, klen, byte);
}

static void
sv_pv_to_key(pTHX_ SV *sv, unsigned char *key, int klen, int *byte) {
    STRLEN len, i;
    char *pv = SvPV(sv, len);
    /* printf("sv: %s, len: %d\n", pv, len); fflush(stdout); */
    for (i = 0; i < klen && i < len; i++)
        key[klen - 1 - i] = pv[i];
    if (*byte < i - 1)
        *byte = i - 1;
    for (; i < klen; i++)
        key[klen - 1 - i] = 0;
}

static void
sv_rpv_to_key(pTHX_ SV *sv, unsigned char *key, int klen, int *byte) {
    STRLEN len, i;
    char *pv = SvPV(sv, len);
    for (i = 0; i < klen && i < len; i++)
        key[klen - 1 - i] = ~pv[i];
    if (*byte < i - 1)
        *byte = i - 1;
    for (; i < klen; i++)
        key[klen - 1 - i] = ~0;
}

static void
radix_sort(pTHX_ IV type, SV *keygen, SV **values, I32 offset, I32 ax, IV n) {
    dSP;
    if (n) {
        unsigned char **keys, **temps, *start;
        int klen, byte;
        int (*calc_klen)(pTHX_ SV **, I32, I32, int);
        void (*sv_to_key)(pTHX_ SV *, unsigned char *, int, int *);
        int hints;
        
        calc_klen = 0;

#if (PERL_VERSION < 9)
        hints = PL_curcop->op_private;
#else
        hints = CopHINTS_get(PL_curcop);
#endif

        if ((type == 2 || type == 130) && (hints & HINT_INTEGER))
            type |= 1;
        
        switch(type) {
        case 2:
            klen = sizeof(NV);
            sv_to_key = &sv_nv_to_key;
            break;
        case 3:
            klen = sizeof(UV);
            sv_to_key = &sv_iv_to_key;
            break;
        case 4:
            klen = sizeof(UV);
            sv_to_key = &sv_uv_to_key;
            break;
        case 5:
            klen = sizeof(float);
            sv_to_key = &sv_sf_to_key;
            break;
        case 7:
            klen = 0;
            calc_klen = *calc_klen_pv;
            sv_to_key = &sv_pv_to_key;
            break;
        case 130:
            klen = sizeof(NV);
            sv_to_key = &sv_rnv_to_key;
            break;
        case 131:
            klen = sizeof(UV);
            sv_to_key = &sv_riv_to_key;
            break;
        case 132:
            klen = sizeof(UV);
            sv_to_key = &sv_ruv_to_key;
            break;
        case 133:
            klen = sizeof(float);
            sv_to_key = &sv_rsf_to_key;
            break;
        case 135:
            klen = 0;
            calc_klen = *calc_klen_pv;
            sv_to_key = &sv_rpv_to_key;
            break;

        default:
            Perl_croak(aTHX_ "internal error: bad ix value");
        }

        if (calc_klen) {
            SV **svkeys = ( keygen
                            ? calc_svkeys(aTHX_ keygen, values, offset, ax, n)
                            : values );
            klen = (*calc_klen)(aTHX_ svkeys, offset, ax, n);
            if (klen) {
                start = init_keys(aTHX_
                                  svkeys, offset, ax, n, NULL,
                                  sv_to_key, &keys, &temps, klen, &byte);

                /* if (n) print_keys("subkeys", keys, n, byte); */
        

            }
        }
        else if (klen)  {
            start = init_keys(aTHX_
                              values, offset, ax, n, keygen,
                              sv_to_key, &keys, &temps, klen, &byte);
        }
        if (byte >= 0) {
            SPAGAIN;
            /* printf("byte: %d\n", byte); */
            radix_sort_1(keys, temps, n, byte);
            
            if (values)
                resort_as_keys(aTHX_
                               values, values, start,
                               ((byte & 1) ? keys : temps),
                               n, klen);
            else
                resort_as_keys(aTHX_
                               &(ST(offset)), &(ST(0)), start,
                               ((byte & 1) ? keys : temps),
                               n, klen);
        }
    }
}

#line 531 "Radix.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 675 "Radix.c"

XS_EUPXS(XS_Sort__Key__Radix__sort); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sort__Key__Radix__sort)
{
    dVAR; dXSARGS;
    dXSI32;
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 537 "Radix.xs"
    radix_sort(aTHX_ ix, 0, 0, 0, ax, items);
    SPAGAIN;
    XSRETURN(items);
#line 691 "Radix.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sort__Key__Radix__sort_inplace); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sort__Key__Radix__sort_inplace)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "values");
    {
#line 545 "Radix.xs"
    AV *magic_values = 0;
    int len;
#line 709 "Radix.c"
	AV *	values;

	if (SvROK(ST(0)) && SvTYPE(SvRV(ST(0)))==SVt_PVAV)
	    values = (AV*)SvRV(ST(0));
	else
	    Perl_croak(aTHX_ "values is not an array reference")
;
#line 559 "Radix.xs"
    if ((len = av_len(values) + 1)) {
        /* warn("ix=%d\n", ix); */
	if (SvMAGICAL(values) || AvREIFY(values)) {
	    int i;
	    magic_values = values;
	    values = (AV*)sv_2mortal((SV*)newAV());
	    av_extend(values, len-1);
	    for (i=0; i<len; i++) {
		SV **currentp = av_fetch(magic_values, i, 0);
		av_store( values, i,
			  ( currentp
			    ? SvREFCNT_inc(*currentp)
			    : newSV(0) ) );
	    }
	}
	radix_sort(aTHX_ ix, 0, AvARRAY(values), 0, 0, len);
        SPAGAIN;
	if (magic_values) {
	    int i;
	    SV **values_array = AvARRAY(values);
	    for(i=0; i<len; i++) {
		SV *current = values_array[i];
		if (!current) current = &PL_sv_undef;
		if (!av_store(magic_values, i, SvREFCNT_inc(current)))
		    SvREFCNT_dec(current);
	    }
	}
    }
#line 746 "Radix.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Sort__Key__Radix__keysort); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sort__Key__Radix__keysort)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items < 1)
       croak_xs_usage(cv,  "keygen, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	keygen = ST(0)
;
#line 603 "Radix.xs"
    radix_sort(aTHX_ ix, keygen, 0, 1, ax, items - 1);
    SPAGAIN;
    XSRETURN(items - 1);
#line 768 "Radix.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sort__Key__Radix__keysort_inplace); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sort__Key__Radix__keysort_inplace)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 2)
       croak_xs_usage(cv,  "keygen, values");
    {
#line 612 "Radix.xs"
    AV *magic_values = 0;
    int len;
#line 786 "Radix.c"
	SV *	keygen = ST(0)
;
	AV *	values;

	if (SvROK(ST(1)) && SvTYPE(SvRV(ST(1)))==SVt_PVAV)
	    values = (AV*)SvRV(ST(1));
	else
	    Perl_croak(aTHX_ "values is not an array reference")
;
#line 626 "Radix.xs"
    if ((len = av_len(values) + 1)) {
        /* warn("ix=%d\n", ix); */
	if (SvMAGICAL(values) || AvREIFY(values)) {
	    int i;
	    magic_values = values;
	    values = (AV*)sv_2mortal((SV*)newAV());
	    av_extend(values, len-1);
	    for (i=0; i<len; i++) {
		SV **currentp = av_fetch(magic_values, i, 0);
		av_store( values, i,
			  ( currentp
			    ? SvREFCNT_inc(*currentp)
			    : newSV(0) ) );
	    }
	}
	radix_sort(aTHX_ ix, keygen, AvARRAY(values), 0, 0, len);
        SPAGAIN;
	if (magic_values) {
	    int i;
	    SV **values_array = AvARRAY(values);
	    for(i=0; i<len; i++) {
		SV *current = values_array[i];
		if (!current) current = &PL_sv_undef;
		if (!av_store(magic_values, i, SvREFCNT_inc(current)))
		    SvREFCNT_dec(current);
	    }
	}
    }
#line 825 "Radix.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Sort__Key__Radix); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Sort__Key__Radix)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

    {
        CV * cv;

        cv = newXS_deffile("Sort::Key::Radix::_sort", XS_Sort__Key__Radix__sort);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("Sort::Key::Radix::fsort", XS_Sort__Key__Radix__sort);
        XSANY.any_i32 = 5;
        cv = newXS_deffile("Sort::Key::Radix::isort", XS_Sort__Key__Radix__sort);
        XSANY.any_i32 = 3;
        cv = newXS_deffile("Sort::Key::Radix::nsort", XS_Sort__Key__Radix__sort);
        XSANY.any_i32 = 2;
        cv = newXS_deffile("Sort::Key::Radix::rfsort", XS_Sort__Key__Radix__sort);
        XSANY.any_i32 = 133;
        cv = newXS_deffile("Sort::Key::Radix::risort", XS_Sort__Key__Radix__sort);
        XSANY.any_i32 = 131;
        cv = newXS_deffile("Sort::Key::Radix::rnsort", XS_Sort__Key__Radix__sort);
        XSANY.any_i32 = 130;
        cv = newXS_deffile("Sort::Key::Radix::rssort", XS_Sort__Key__Radix__sort);
        XSANY.any_i32 = 135;
        cv = newXS_deffile("Sort::Key::Radix::rusort", XS_Sort__Key__Radix__sort);
        XSANY.any_i32 = 132;
        cv = newXS_deffile("Sort::Key::Radix::ssort", XS_Sort__Key__Radix__sort);
        XSANY.any_i32 = 7;
        cv = newXS_deffile("Sort::Key::Radix::usort", XS_Sort__Key__Radix__sort);
        XSANY.any_i32 = 4;
        cv = newXSproto_portable("Sort::Key::Radix::_sort_inplace", XS_Sort__Key__Radix__sort_inplace, file, "\\@");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("Sort::Key::Radix::fsort_inplace", XS_Sort__Key__Radix__sort_inplace, file, "\\@");
        XSANY.any_i32 = 5;
        cv = newXSproto_portable("Sort::Key::Radix::isort_inplace", XS_Sort__Key__Radix__sort_inplace, file, "\\@");
        XSANY.any_i32 = 3;
        cv = newXSproto_portable("Sort::Key::Radix::nsort_inplace", XS_Sort__Key__Radix__sort_inplace, file, "\\@");
        XSANY.any_i32 = 2;
        cv = newXSproto_portable("Sort::Key::Radix::rfsort_inplace", XS_Sort__Key__Radix__sort_inplace, file, "\\@");
        XSANY.any_i32 = 133;
        cv = newXSproto_portable("Sort::Key::Radix::risort_inplace", XS_Sort__Key__Radix__sort_inplace, file, "\\@");
        XSANY.any_i32 = 131;
        cv = newXSproto_portable("Sort::Key::Radix::rnsort_inplace", XS_Sort__Key__Radix__sort_inplace, file, "\\@");
        XSANY.any_i32 = 130;
        cv = newXSproto_portable("Sort::Key::Radix::rssort_inplace", XS_Sort__Key__Radix__sort_inplace, file, "\\@");
        XSANY.any_i32 = 135;
        cv = newXSproto_portable("Sort::Key::Radix::rusort_inplace", XS_Sort__Key__Radix__sort_inplace, file, "\\@");
        XSANY.any_i32 = 132;
        cv = newXSproto_portable("Sort::Key::Radix::ssort_inplace", XS_Sort__Key__Radix__sort_inplace, file, "\\@");
        XSANY.any_i32 = 7;
        cv = newXSproto_portable("Sort::Key::Radix::usort_inplace", XS_Sort__Key__Radix__sort_inplace, file, "\\@");
        XSANY.any_i32 = 4;
        cv = newXSproto_portable("Sort::Key::Radix::_keysort", XS_Sort__Key__Radix__keysort, file, "&@");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("Sort::Key::Radix::fkeysort", XS_Sort__Key__Radix__keysort, file, "&@");
        XSANY.any_i32 = 5;
        cv = newXSproto_portable("Sort::Key::Radix::ikeysort", XS_Sort__Key__Radix__keysort, file, "&@");
        XSANY.any_i32 = 3;
        cv = newXSproto_portable("Sort::Key::Radix::nkeysort", XS_Sort__Key__Radix__keysort, file, "&@");
        XSANY.any_i32 = 2;
        cv = newXSproto_portable("Sort::Key::Radix::rfkeysort", XS_Sort__Key__Radix__keysort, file, "&@");
        XSANY.any_i32 = 133;
        cv = newXSproto_portable("Sort::Key::Radix::rikeysort", XS_Sort__Key__Radix__keysort, file, "&@");
        XSANY.any_i32 = 131;
        cv = newXSproto_portable("Sort::Key::Radix::rnkeysort", XS_Sort__Key__Radix__keysort, file, "&@");
        XSANY.any_i32 = 130;
        cv = newXSproto_portable("Sort::Key::Radix::rskeysort", XS_Sort__Key__Radix__keysort, file, "&@");
        XSANY.any_i32 = 135;
        cv = newXSproto_portable("Sort::Key::Radix::rukeysort", XS_Sort__Key__Radix__keysort, file, "&@");
        XSANY.any_i32 = 132;
        cv = newXSproto_portable("Sort::Key::Radix::skeysort", XS_Sort__Key__Radix__keysort, file, "&@");
        XSANY.any_i32 = 7;
        cv = newXSproto_portable("Sort::Key::Radix::ukeysort", XS_Sort__Key__Radix__keysort, file, "&@");
        XSANY.any_i32 = 4;
        cv = newXSproto_portable("Sort::Key::Radix::_keysort_inplace", XS_Sort__Key__Radix__keysort_inplace, file, "&\\@");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("Sort::Key::Radix::fkeysort_inplace", XS_Sort__Key__Radix__keysort_inplace, file, "&\\@");
        XSANY.any_i32 = 5;
        cv = newXSproto_portable("Sort::Key::Radix::ikeysort_inplace", XS_Sort__Key__Radix__keysort_inplace, file, "&\\@");
        XSANY.any_i32 = 3;
        cv = newXSproto_portable("Sort::Key::Radix::nkeysort_inplace", XS_Sort__Key__Radix__keysort_inplace, file, "&\\@");
        XSANY.any_i32 = 2;
        cv = newXSproto_portable("Sort::Key::Radix::rfkeysort_inplace", XS_Sort__Key__Radix__keysort_inplace, file, "&\\@");
        XSANY.any_i32 = 133;
        cv = newXSproto_portable("Sort::Key::Radix::rikeysort_inplace", XS_Sort__Key__Radix__keysort_inplace, file, "&\\@");
        XSANY.any_i32 = 131;
        cv = newXSproto_portable("Sort::Key::Radix::rnkeysort_inplace", XS_Sort__Key__Radix__keysort_inplace, file, "&\\@");
        XSANY.any_i32 = 130;
        cv = newXSproto_portable("Sort::Key::Radix::rskeysort_inplace", XS_Sort__Key__Radix__keysort_inplace, file, "&\\@");
        XSANY.any_i32 = 135;
        cv = newXSproto_portable("Sort::Key::Radix::rukeysort_inplace", XS_Sort__Key__Radix__keysort_inplace, file, "&\\@");
        XSANY.any_i32 = 132;
        cv = newXSproto_portable("Sort::Key::Radix::skeysort_inplace", XS_Sort__Key__Radix__keysort_inplace, file, "&\\@");
        XSANY.any_i32 = 7;
        cv = newXSproto_portable("Sort::Key::Radix::ukeysort_inplace", XS_Sort__Key__Radix__keysort_inplace, file, "&\\@");
        XSANY.any_i32 = 4;
    }
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

